﻿using System;

using DevExpress.XtraEditors;
using DevExpress.XtraEditors.Repository;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.checkedComboBoxEdit.Properties.SetFlags(typeof(ColorType));

            RemoveCombinedFlag(checkedComboBoxEdit.Properties);

            this.checkedComboBoxEdit.SetEditValue(ColorType.Black | ColorType.Green);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 결합 플래그 제거하기 - RemoveCombinedFlag(repositoryItemCheckedComboBoxEdit)

        /// <summary>
        /// 결합 플래그 제거하기
        /// </summary>
        /// <param name="repositoryItemCheckedComboBoxEdit">저장소 항목 체크 콤보 박스 에디터</param>
        private void RemoveCombinedFlag(RepositoryItemCheckedComboBoxEdit repositoryItemCheckedComboBoxEdit)
        {
            for(int i = repositoryItemCheckedComboBoxEdit.Items.Count - 1; i > 0; i--)
            {
                Enum value1 = repositoryItemCheckedComboBoxEdit.Items[i].Value as Enum;

                for(int j = i - 1; j >= 0; j--)
                {
                    Enum value2 = repositoryItemCheckedComboBoxEdit.Items[j].Value as Enum;

                    if(value1.HasFlag(value2))
                    {
                        repositoryItemCheckedComboBoxEdit.Items.RemoveAt(i);

                        break;
                    }
                }
            }
        }

        #endregion
    }
}